Index: branches/new_class_id/src/defs/class_id.h
===================================================================
--- branches/new_class_id/src/defs/class_id.h	(revision 9707)
+++ branches/new_class_id/src/defs/class_id.h	(revision 9709)
@@ -224,5 +224,5 @@
   CL_FPS_SNIPER_RIFLE           =    0x000003a7,
   CL_FPS_LASER_RIFLE            =    0x000003a8,
-  CL_BOOMERANG_GUN              =    0x00000309,
+  CL_BOOMERANG_GUN              =    0x000003a9,
 
   // Projectiles
@@ -237,5 +237,5 @@
   CL_GUIDED_MISSILE             =    0x000003e8,
   CL_HYPERBLAST                 =    0x000003e9,
-  CL_BOOMERANG_PROJECTILE       =    0x0000030a,
+  CL_BOOMERANG_PROJECTILE       =    0x000003ea,
 
   // NPC's
@@ -253,5 +253,5 @@
 
   CL_IMAGE_ENTITY               =    0x00000513,
-  CL_IMAGE_PLANE                =    0x00000514,
+  CL_IMAGE_PLANE                =    0x00000518,
   CL_MODEL_ENTITY               =    0x00000515,
   CL_TEXT_ELEMENT               =    0x00000516, /// TODO MOVE
Index: branches/new_class_id/src/lib/BuildLibs.am
===================================================================
--- branches/new_class_id/src/lib/BuildLibs.am	(revision 9707)
+++ branches/new_class_id/src/lib/BuildLibs.am	(revision 9709)
@@ -1,15 +1,9 @@
 
 libORXlibs_a_LIBRARIES_ = \
-                $(LIB_PREFIX)/util/libORXlibutil.a \
-                $(LIB_PREFIX)/shell/libORXshell.a \
                 $(LIB_PREFIX)/event/libORXevent.a \
                 $(LIB_PREFIX)/gui/qt/libORXqtgui.a \
                 $(LIB_PREFIX)/gui/gl/libORXglgui.a \
                 $(LIB_PREFIX)/gui/libORXbasegui.a \
-                $(LIB_PREFIX)/script_engine/libORXscript.a \
-                $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
                 $(LIB_PREFIX)/graphics/libORXgraphics.a \
-                $(LIB_PREFIX)/graphics/importer/libtc.a \
-                $(LIB_PREFIX)/sound/libORXsound.a \
                 $(LIB_PREFIX)/particles/libORXparticles.a \
                 $(LIB_PREFIX)/collision_detection/libORXcd.a \
@@ -23,7 +17,15 @@
                 $(LIB_PREFIX)/physics/libORXphysics.a \
                 $(LIB_PREFIX)/gui/gl/libORXglgui.a \
+                \
+                $(LIB_PREFIX)/util/libORXlibutil.a \
+                \
+                $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
+                $(LIB_PREFIX)/graphics/importer/libtc.a \
+                $(LIB_PREFIX)/sound/libORXsound.a \
                 $(LIB_PREFIX)/shell/libORXshell.a \
-                $(LIB_PREFIX)/math/libORXmath.a \
+                $(LIB_PREFIX)/script_engine/libORXscript.a \
+                $(LIB_PREFIX)/util/libORXexecutor.a \
                 $(LIB_PREFIX)/util/libORXlibutil.a \
                 $(LIB_PREFIX)/lang/libORXlang.a \
-                $(LIB_PREFIX)/libORXlibs.a
+                $(LIB_PREFIX)/libORXlibs.a \
+                $(LIB_PREFIX)/math/libORXmath.a
Index: branches/new_class_id/src/lib/Makefile.am
===================================================================
--- branches/new_class_id/src/lib/Makefile.am	(revision 9707)
+++ branches/new_class_id/src/lib/Makefile.am	(revision 9709)
@@ -16,6 +16,6 @@
 		data/data_tank.h
 
-SUBDIRS =
-#	. \
+SUBDIRS = \
+	. \
 	math \
 	lang \
Index: branches/new_class_id/src/lib/coord/p_node.cc
===================================================================
--- branches/new_class_id/src/lib/coord/p_node.cc	(revision 9707)
+++ branches/new_class_id/src/lib/coord/p_node.cc	(revision 9709)
@@ -29,4 +29,6 @@
 #include "color.h"
 
+
+NewObjectListDefinition(PNode);
 /**
  * @brief standard constructor
Index: branches/new_class_id/src/lib/graphics/effects/cloud_effect.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/effects/cloud_effect.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/effects/cloud_effect.cc	(revision 9709)
@@ -40,4 +40,5 @@
 float     CloudEffect::fadeTime;
 
+NewObjectListDefinitionID(CloudEffect, CL_CLOUD_EFFECT);
 
 
@@ -56,6 +57,5 @@
 
 
-CREATE_FACTORY(CloudEffect, CL_CLOUD_EFFECT);
-NewObjectListDefinitionID(CloudEffect, CL_CLOUD_EFFECT);
+CREATE_FACTORY(CloudEffect);
 
 CloudEffect::CloudEffect(const TiXmlElement* root) {
Index: branches/new_class_id/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/effects/fog_effect.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/effects/fog_effect.cc	(revision 9709)
@@ -22,4 +22,5 @@
 #include "cloud_effect.h"
 
+NewObjectListDefinition(FogEffect);
 // Define shell commands
 //SHELL_COMMAND(activate, FogEffect, activateFog);
@@ -37,6 +38,5 @@
                        );
 
-CREATE_FACTORY(FogEffect, CL_FOG_EFFECT);
-NewObjectListDefinition(FogEffect);
+CREATE_FACTORY(FogEffect);
 
 /**
Index: branches/new_class_id/src/lib/graphics/effects/lense_flare.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/effects/lense_flare.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/effects/lense_flare.cc	(revision 9709)
@@ -35,6 +35,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(LenseFlare, CL_LENSE_FLARE);
 NewObjectListDefinitionID(LenseFlare, CL_LENSE_FLARE);
+CREATE_FACTORY(LenseFlare);
 
 /**
Index: branches/new_class_id/src/lib/graphics/effects/lightning_effect.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/effects/lightning_effect.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/effects/lightning_effect.cc	(revision 9709)
@@ -29,4 +29,6 @@
 #include "class_id.h"
 
+NewObjectListDefinitionID(LightningEffect, CL_LIGHTNING_EFFECT);
+
 SHELL_COMMAND(activate, LightningEffect, activateLightning);
 SHELL_COMMAND(deactivate, LightningEffect, deactivateLightning);
@@ -37,6 +39,5 @@
                        );
 
-CREATE_FACTORY(LightningEffect, CL_LIGHTNING_EFFECT);
-NewObjectListDefinitionID(LightningEffect, CL_LIGHTNING_EFFECT);
+CREATE_FACTORY(LightningEffect);
 
 LightningEffect::LightningEffect(const TiXmlElement* root) {
Index: branches/new_class_id/src/lib/graphics/effects/rain_effect.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/effects/rain_effect.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/effects/rain_effect.cc	(revision 9709)
@@ -33,4 +33,6 @@
 #include "class_id.h"
 
+NewObjectListDefinitionID(RainEffect, CL_RAIN_EFFECT);
+
 // Define shell commands
 //SHELL_COMMAND(activate, RainEffect, activateRain);
@@ -48,6 +50,5 @@
                        );
 
-CREATE_FACTORY(RainEffect, CL_RAIN_EFFECT);
-NewObjectListDefinitionID(RainEffect, CL_RAIN_EFFECT);
+CREATE_FACTORY(RainEffect);
 
 /**
Index: branches/new_class_id/src/lib/graphics/effects/snow_effect.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/effects/snow_effect.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/effects/snow_effect.cc	(revision 9709)
@@ -32,4 +32,5 @@
 #include "class_id.h"
 
+NewObjectListDefinitionID(SnowEffect, CL_SNOW_EFFECT);
 SHELL_COMMAND(activate, SnowEffect, activateSnow);
 SHELL_COMMAND(deactivate, SnowEffect, deactivateSnow);
@@ -41,6 +42,5 @@
                        );
 
-CREATE_FACTORY(SnowEffect, CL_SNOW_EFFECT);
-NewObjectListDefinitionID(SnowEffect, CL_SNOW_EFFECT);
+CREATE_FACTORY(SnowEffect);
 
 SnowEffect::SnowEffect(const TiXmlElement* root)
Index: branches/new_class_id/src/lib/graphics/effects/volfog_effect.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/effects/volfog_effect.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/effects/volfog_effect.cc	(revision 9709)
@@ -48,7 +48,6 @@
 
 #include "class_id.h"
-
-CREATE_FACTORY(VolFogEffect, CL_VOLFOG_EFFECT);
 NewObjectListDefinitionID(VolFogEffect, CL_VOLFOG_EFFECT);
+CREATE_FACTORY(VolFogEffect);
 
 VolFogEffect::VolFogEffect(const TiXmlElement* root) {
Index: branches/new_class_id/src/lib/graphics/light.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/light.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/light.cc	(revision 9709)
@@ -29,6 +29,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(Light, CL_LIGHT);
 NewObjectListDefinitionID(Light, CL_LIGHT);
+CREATE_FACTORY(Light);
 
 //! Definition of the Lights and their Names
Index: branches/new_class_id/src/lib/graphics/render2D/image_plane.cc
===================================================================
--- branches/new_class_id/src/lib/graphics/render2D/image_plane.cc	(revision 9707)
+++ branches/new_class_id/src/lib/graphics/render2D/image_plane.cc	(revision 9709)
@@ -25,7 +25,7 @@
 
 #include "class_id.h"
-CREATE_FACTORY(ImagePlane, CL_IMAGE_ENTITY);
 
-NewObjectListDefinitionID(ImagePlane, CL_IMAGE_ENTITY);
+NewObjectListDefinitionID(ImagePlane, CL_IMAGE_PLANE);
+CREATE_FACTORY(ImagePlane);
 
 
Index: branches/new_class_id/src/lib/gui/gl/glmenu/glmenu_imagescreen.cc
===================================================================
--- branches/new_class_id/src/lib/gui/gl/glmenu/glmenu_imagescreen.cc	(revision 9707)
+++ branches/new_class_id/src/lib/gui/gl/glmenu/glmenu_imagescreen.cc	(revision 9709)
@@ -26,6 +26,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(GLMenuImageScreen, CL_GLMENU_IMAGE_SCREEN);
 NewObjectListDefinitionID(GLMenuImageScreen, CL_GLMENU_IMAGE_SCREEN);
+CREATE_FACTORY(GLMenuImageScreen);
 
 /**
Index: branches/new_class_id/src/lib/lang/base_object.h
===================================================================
--- branches/new_class_id/src/lib/lang/base_object.h	(revision 9707)
+++ branches/new_class_id/src/lib/lang/base_object.h	(revision 9709)
@@ -44,7 +44,7 @@
   //inline const std::string& getClassName() const { return this->className; }
   /** @returns the className of the corresponding Object as a C-compliant string (const char*) */
-  inline const char* getClassCName() const { return this->className.c_str(); };
+  inline const char* getClassCName() const { return _classes.front()._objectList->name().c_str(); };
   /** @returns the ClassName of the Topmost Object of the ClassStack */
-  inline const std::string& getClassName() const { return _classes.front()._objectList->name(); }
+  inline const std::string& getClassName() const { return _classes.front()._objectList->name(); };
 
   inline const NewClassID& getClassID() const { return *_leafClassID; }
Index: branches/new_class_id/src/lib/lang/new_class_id.cc
===================================================================
--- branches/new_class_id/src/lib/lang/new_class_id.cc	(revision 9707)
+++ branches/new_class_id/src/lib/lang/new_class_id.cc	(revision 9709)
@@ -19,16 +19,25 @@
 #include "new_object_list.h"
 
+/**
+ * @brief a Default Constructor.
+ * this Always points to the ID of the NullClass.
+ */
 NewClassID::NewClassID()
 {
-  *this = NullClass::classID();
+  NullClass::acquireID(this->_id, this->_name);
 };
 
-NewClassID::NewClassID(const NewObjectListBase* objList)
+/**
+ * @brief Acquiring the ID of a objectList.
+ * @param objList The NewObjectList to acquire the ID from.
+ */
+NewClassID::NewClassID(const NewObjectListBase* const objList)
 {
-
-  objList->acquireID(_id, _name);
-
+  objList->acquireID(this->_id, this->_name);
 }
 
 
 NewClassID NullClass::_classID;
+
+int NullClass::_nullID;
+const std::string NullClass::_nullName = std::string("NullClass");
Index: branches/new_class_id/src/lib/lang/new_class_id.h
===================================================================
--- branches/new_class_id/src/lib/lang/new_class_id.h	(revision 9707)
+++ branches/new_class_id/src/lib/lang/new_class_id.h	(revision 9709)
@@ -12,34 +12,64 @@
 class NewObjectListBase;
 
-//! A class to dynamically allocate ClassID's and support a isA operator
+//! A class to dynamically allocate ClassID's and to support a isA operator
+/**
+ * A NewClassID can only be aquired over a NewObjectList,
+ * thus enabling the developer to have permanent access to the correct ID and ClassName
+ *
+ * The Idea behind this concept is, that storing a NewClassID that changes its internal state
+ * all NewClassID's will be updated correctly.
+ *
+ * Since the Existance of any NewObjectList is a requirement during the working process all
+ * ID's should reference a valid ID and ClassName
+ */
 class NewClassID
 {
 public:
   NewClassID();
-  NewClassID(const NewObjectListBase* id);
-  // the copy constructor is also defined.
+  NewClassID(const NewObjectListBase* const id);
+  /// the copy constructor is also defined implicitely.
+
+  /** @returns A constant reference to the ID. */
   const int& id() const { return *_id; };
+  /** @returns A constant reference to the Name. */
   const std::string& name() const { return *_name; };
 
+  /** @param id the id to compare @returns true on match (match is same ID) @brief compares two id's */
   bool operator==(const NewClassID& id) const { return *_id == *id._id /* || _name == id._name */; };
+  /** @param id the id to compare @returns true on match (match is same ID) @brief compares two id's */
   bool operator==(int id) const { return *_id == id; };
+  /** @param name the id to compare @returns true on match (match is same Name) @brief compares an ID with a ClassName */
   bool operator==(const std::string& name) const { return *_name == name; };
+  /** @param id the id to compare @returns false on match (match is same ID) @brief compares two id's */
   bool operator!=(const NewClassID& id) const { return *_id != *id._id /* && _name != id._name*/;  };
+  /** @param id the id to compare @returns false on match (match is same ID) @brief compares two id's */
   bool operator!=(int id) const { return *_id != id; };
+  /** @param name the id to compare @returns false on match (match is same Name) @brief compares an ID with a ClassName */
   bool operator!=(const std::string& name) const { return *_name != name; };
 
 private:
-  const int*                _id;
-  const std::string*        _name;
+  const int*                _id;           //!< A pointer to the ID of the ClassID.
+  const std::string*        _name;         //!< A pointer to the Name of the ClassID.
 };
 
+//! A NullClass. This is the Null of the ClassID.
+/**
+ * implemented as a Class id can be used to reference NullObjects.
+ */
 class NullClass
 {
 public:
-  static NewClassID classID() { return NullClass::_classID; }
+  /** @returns the NullClass' ID. */
+  static const NewClassID& classID() { return NullClass::_classID; }
+  /** @param id the ID to acquire @param name the name to acquire @brief acquires the ID of this Class */
+  static void acquireID(const int*& id, const std::string*& name) { id = &_nullID; name = &_nullName; };
+
 private:
-  NullClass();
+  NullClass() {}; //!< The Default Constructor is hidden from the User.
+
 private:
-  static NewClassID _classID;
+  static NewClassID         _classID;      //!< The NullClass' ID
+  static const std::string  _nullName;     //!< The NullClass' Name ("NullClass")
+  static int                _nullID;       //!< The NullClass' ID
 };
 
Index: branches/new_class_id/src/lib/lang/new_object_list.cc
===================================================================
--- branches/new_class_id/src/lib/lang/new_object_list.cc	(revision 9707)
+++ branches/new_class_id/src/lib/lang/new_object_list.cc	(revision 9709)
@@ -20,4 +20,6 @@
 
 
+#include <stdio.h>
+
 /**
  * @brief Constructor, that creates an ObjectList while checking (development mode) for uniqueness of all Keys (names and ID's)
@@ -27,6 +29,7 @@
  */
 NewObjectListBase::NewObjectListBase(const std::string& className, int id)
-  : _name(className)
-{
+    : _name(className)
+{
+  printf("NewObjectList, Registered %s::%d\n", className.c_str(), id);
   if (NewObjectListBase::_classesByID == NULL)
   {
@@ -47,5 +50,5 @@
   _id = id;
   /// Some Output, that will fall out later
-  //std::cout << "register new ObjectList " << className << " ID: " << this->_id << std::endl;
+  std::cout << "register new ObjectList " << className << " ID: " << this->_id << std::endl;
 
   this->_identity = NewClassID(this);
@@ -98,4 +101,14 @@
  * @return true if such a class already exists.
  */
+bool NewObjectListBase::classIDExists(int id)
+{
+  return (NewObjectListBase::_classesByID->find(id) != NewObjectListBase::_classesByID->end());
+}
+
+/**
+ * @brief Checks if a Class with name already exists.
+ * @param name The Name of the Class to check.
+ * @return true if such a class already exists.
+ */
 bool NewObjectListBase::classNameExists(const std::string& name)
 {
@@ -108,5 +121,5 @@
  * @returns the ClassID if found and NullClass' identity if not.
  */
-const NewClassID& NewObejctListBase::retrieveIdentity(int id)
+const NewClassID& NewObjectListBase::retrieveIdentity(int id)
 {
   const NewObjectListBase* const base = NewObjectListBase::getObjectList(id);
@@ -117,4 +130,5 @@
     return NullClass::classID();
 }
+
 
 /**
@@ -130,16 +144,5 @@
     return base->_identity;
   else
-    return NullObject::classID();
-}
-
-
-/**
- * @brief Checks if a Class with name already exists.
- * @param name The Name of the Class to check.
- * @return true if such a class already exists.
- */
-bool NewObjectListBase::classIDExists(int id)
-{
-  return (NewObjectListBase::_classesByID->find(id) != NewObjectListBase::_classesByID->end());
+    return NullClass::classID();
 }
 
@@ -230,4 +233,45 @@
 }
 
+#include "base_object.h"
+
+/**
+ * @brief Prints out some debugging information about a given List.
+ */
+void NewObjectListBase::debug(unsigned int level) const
+{
+  base_list list;
+  this->getBaseObjectList(&list);
+
+  if (level > 1 || !list.empty())
+    printf(" ObjectList of class %s(id:%d) contains %d objects\n", this->name().c_str(), this->id(), list.size());
+
+  if (level >= 2)
+  {
+    printf("  - listing Instances: \n");
+    for (base_iterator it = list.begin();
+         it != list.end();
+         ++it)
+    {
+      printf("   + %s::%s\n", (*it)->getClassCName(), (*it)->getCName());
+    }
+  }
+}
+
+
+void NewObjectListBase::debugAll(unsigned int level)
+{
+  printf("Listing all %d ObjectLists \n", NewObjectListBase::_classesByID->size());
+
+  for (classNameMap::const_iterator it = NewObjectListBase::_classesByName->begin();
+       it != NewObjectListBase::_classesByName->end();
+       ++it)
+  {
+    (*it).second->debug(level);
+
+  }
+
+}
+
+
 
 /**
Index: branches/new_class_id/src/lib/lang/new_object_list.h
===================================================================
--- branches/new_class_id/src/lib/lang/new_object_list.h	(revision 9707)
+++ branches/new_class_id/src/lib/lang/new_object_list.h	(revision 9709)
@@ -48,27 +48,29 @@
   class IteratorBase { };
 
-  typedef std::list<BaseObject*>            base_list;
-  typedef base_list::iterator               base_iterator;
+  /** @brief A Typedefinition for the Base-List that can be retrieved with getBaseObjectList(base_list*) */
+  typedef std::list<BaseObject*>        base_list;
+  /** @brief An iterator for the base_list */
+  typedef base_list::iterator           base_iterator;
 
 public:
   /** @returns The Identity of the Class stored within. */
-  inline const NewClassID& identity() const { return _identity; }
+  inline const NewClassID&              identity() const { return _identity; }
   /** @returns the ID of the Identity of the ObjectList */
-  inline int id() const { return _id; };
+  inline int                            id() const { return _id; };
   /** @returns The Name of the Class stored in this ObjectList */
-  inline const std::string& name() const { return _name; };
+  inline const std::string&             name() const { return _name; };
   /** @param id The id to compare @returns true on match, false otherwise */
-  inline bool operator==(int id) const { return _id == id; };
+  inline bool                           operator==(int id) const { return _id == id; };
   /** @param id The id to compare @returns true on match, false otherwise */
-  inline bool operator==(const NewClassID& id) const { return id == _id; };
+  inline bool                           operator==(const NewClassID& id) const { return id == _id; };
   /** @param name The name to compare @returns true on match, false otherwise */
-  inline bool operator==(const std::string& name) const { return _name == name; };
+  inline bool                           operator==(const std::string& name) const { return _name == name; };
   /** @param id The id to check @returns true on match, false otherwise */
-  inline void acquireID(const int*& id, const std::string*& name) const { id = &_id; name = &_name; };
+  inline void                           acquireID(const int*& id, const std::string*& name) const { id = &_id; name = &_name; };
   /** @brief fills a list of Objects into a BaseObject*-List. @param list the list to fill */
-  virtual void getBaseObjectList(base_list* list) const = 0;
-
-  static const NewClassID& retrieveIdentity(int id);
-  static const NewClassID& retrieveIdentity(const std::string& name);
+  virtual void                          getBaseObjectList(base_list* list) const = 0;
+
+  static const NewClassID&              retrieveIdentity(int id);
+  static const NewClassID&              retrieveIdentity(const std::string& name);
 
   static const NewObjectListBase* const getObjectList(int classID);
@@ -76,21 +78,23 @@
   static const NewObjectListBase* const getObjectList(const NewClassID& classID);
 
-  static BaseObject* getBaseObject(int classID, const std::string& objectName);
-  static BaseObject* getBaseObject(const std::string& className, const std::string& objectName);
-  static BaseObject* getBaseObject(const NewClassID& classID, const std::string& objectName);
+  static BaseObject*                    getBaseObject(int classID, const std::string& objectName);
+  static BaseObject*                    getBaseObject(const std::string& className, const std::string& objectName);
+  static BaseObject*                    getBaseObject(const NewClassID& classID, const std::string& objectName);
 
   /** @returns an Object with Name name out of this List @param name the name of the Object. */
-  virtual BaseObject* getBaseObject(const std::string& name) const = 0;
+  virtual BaseObject*                   getBaseObject(const std::string& name) const = 0;
 
   static const std::list<std::string>&  getClassNames();
 
+
   static unsigned int                   classCount();
+  void                                  debug(unsigned int level) const;
+  static void                           debugAll(unsigned int level);
+
   static const std::string&             IDToString(int classID);
   static int                            StringToID(const std::string& className);
 
-  virtual void debug() const = 0;
-
   //! Only uset to unsubscribe a BaseObject.
-  virtual void unregisterObject(IteratorBase* _iterators) = 0;
+  virtual void                          unregisterObject(IteratorBase* _iterators) = 0;
 
 protected:
@@ -101,6 +105,6 @@
   NewObjectListBase(const NewObjectListBase&);
 
-  static bool classIDExists(int id);
-  static bool classNameExists(const std::string& className);
+  static bool                         classIDExists(int id);
+  static bool                         classNameExists(const std::string& className);
 
 
@@ -126,4 +130,13 @@
 //! Defines a ObjectsList handler for objects of type T.
 /**
+ * The ObjectList is a generic way to store every object created from a Class 'T'
+ *  into a List. The list can be retrieved, and used constantly over iterators,
+ *  as with normal std::list.
+ *
+ * Furthermore the linkage over the single Lists is given over the Superclass NewObjectListBase.
+ *
+ *
+ *
+ *
  * To define a Class with a ObjectList, you have to:
  *  1. Include 'NewObjectListDeclaration(T);' in its Declaration (at the beginning)
@@ -132,4 +145,22 @@
  *
  * @note The Class must define the compare with const std::string& operator for this to work.
+ *
+ *
+ *
+ * Limitations:
+ *  ObjectList cannot be used with other Factory style Classes, if the class is also a BaseObject,
+ *   and not loaded before the ObjectList.
+ *
+ * @example Iterating: Iteration is made easy, and fast as follows:
+ *   for (NewObjectList<PlayerStats>::const_iterator it = PlayerStats::objectList().begin();
+ *      it != PlayerStats::objectList().end();
+ *     ++it)
+ *   {
+ *    (*it)->dosomething
+ *   }
+ *
+ * @example Find an Object:
+ * Playable* playable = Playable::objectList("orxonox-super-rocket-fighter"); // searches an Object By its name.
+ *
  */
 template<class T>
@@ -154,27 +185,33 @@
   ~NewObjectList();
 
-  virtual BaseObject*     getBaseObject(const std::string& name) const;
-  T*                      getObject(const std::string& name) const;
-  inline const list&      objects() const { return _objects; };
-  bool exists(const T* const object) const;
-
-  inline iterator begin() { return _objects.begin(); };
-  inline const_iterator begin() const { return _objects.begin(); };
-  inline iterator  end() { return _objects.end(); };
-  inline const_iterator  end() const { return _objects.end(); };
-
-  inline bool empty() const { return _objects.empty(); };
-  inline int size() const { return _objects.size(); };
-  inline T* front() const { return _objects.front(); };
-  inline T* back() const { return _objects.back(); };
-
-
-  NewObjectListBase::IteratorBase* registerObject(T* object);
-  virtual void unregisterObject(IteratorBase* iterator);
-
-  virtual void debug() const;
+  virtual BaseObject*                getBaseObject(const std::string& name) const;
+  T*                                 getObject(const std::string& name) const;
+  inline const list&                 objects() const { return _objects; };
+  bool                               exists(const T* const object) const;
+
+  /** @returns an Iterator to the beginning of the List. */
+  inline iterator                    begin() { return _objects.begin(); };
+  /** @returns a constant Iterator to the beginning of the List. */
+  inline const_iterator              begin() const { return _objects.begin(); };
+  /** @returns an Iterator to the end of the List. */
+  inline iterator                    end() { return _objects.end(); };
+  /** @returns a constant Iterator to the beginning of the List. */
+  inline const_iterator              end() const { return _objects.end(); };
+
+  /** @returns true if the List is empty. */
+  inline bool                        empty() const { return _objects.empty(); };
+  /** @returns the size of the List */
+  inline int                         size() const { return _objects.size(); };
+  /** @returns the frontmost Element of the list (normaly the last added Object). */
+  inline T*                          front() const { return _objects.front(); };
+  /** @returns the last added Object */
+  inline T*                          back() const { return _objects.back(); };
+
+
+  NewObjectListBase::IteratorBase*   registerObject(T* object);
+  virtual void                       unregisterObject(IteratorBase* iterator);
 
 protected:
-  virtual void getBaseObjectList(NewObjectListBase::base_list* list) const;
+  virtual void                       getBaseObjectList(NewObjectListBase::base_list* list) const;
 
 
@@ -184,5 +221,5 @@
 
 private:
-  list                _objects;
+  list                _objects;     //!< The List of stored Objects of Type T.
 };
 
@@ -212,6 +249,5 @@
   if (!_objects.empty())
   {
-    std::cout << "There are still Object in the ObjectList of " << this->name() << "(id:" << this->id() << ")\n";
-    this->debug();
+    // std::cout << "There are " << this->size() << " objects from class " << this->name() << "(id:" << this->id() << ") in existance\n";
   }
 }
@@ -279,6 +315,6 @@
 NewObjectListBase::IteratorBase* NewObjectList<T>::registerObject(T* object)
 {
-  this->_objects.push_front(object);
-  return new Iterator(this->_objects.begin());
+  this->_objects.push_back(object);
+  return new Iterator(--this->_objects.end());
 }
 
@@ -294,17 +330,3 @@
 }
 
-/**
- * @brief print out some debug information
- * @note this function will most probably vanish from here and be completely moved to the base class.
- */
-template <class T>
-void NewObjectList<T>::debug() const
-{
-  const_iterator it;
-  for (it = this->_objects.begin(); it != this->_objects.end(); ++it)
-  {
-    std::cout << (*it)->getName() << std::endl;
-  }
-}
-
 #endif /* _NEW_OBJECT_LIST_H */
Index: branches/new_class_id/src/lib/network/network_stream.cc
===================================================================
--- branches/new_class_id/src/lib/network/network_stream.cc	(revision 9707)
+++ branches/new_class_id/src/lib/network/network_stream.cc	(revision 9709)
@@ -1194,5 +1194,5 @@
           }
           else
-            b = Factory::fabricate( leafClassId );
+	    ; /// FIXME NEW_CLASS_ID :: b = Factory::fabricate( leafClassId );
 
           if ( !b )
Index: branches/new_class_id/src/lib/network/player_stats.cc
===================================================================
--- branches/new_class_id/src/lib/network/player_stats.cc	(revision 9707)
+++ branches/new_class_id/src/lib/network/player_stats.cc	(revision 9709)
@@ -32,6 +32,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(PlayerStats, CL_PLAYER_STATS);
 NewObjectListDefinitionID(PlayerStats, CL_PLAYER_STATS);
+CREATE_FACTORY(PlayerStats);
 
 /**
Index: branches/new_class_id/src/lib/particles/box_emitter.cc
===================================================================
--- branches/new_class_id/src/lib/particles/box_emitter.cc	(revision 9707)
+++ branches/new_class_id/src/lib/particles/box_emitter.cc	(revision 9709)
@@ -26,6 +26,7 @@
 #include "class_id.h"
 
-CREATE_FACTORY(BoxEmitter, CL_BOX_EMITTER);
 NewObjectListDefinitionID(BoxEmitter, CL_BOX_EMITTER);
+CREATE_FACTORY(BoxEmitter);
+
 /**
  *  standard constructor
Index: branches/new_class_id/src/lib/particles/dot_emitter.cc
===================================================================
--- branches/new_class_id/src/lib/particles/dot_emitter.cc	(revision 9707)
+++ branches/new_class_id/src/lib/particles/dot_emitter.cc	(revision 9709)
@@ -27,6 +27,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(DotEmitter, CL_DOT_EMITTER);
 NewObjectListDefinitionID(DotEmitter, CL_DOT_EMITTER);
+CREATE_FACTORY(DotEmitter);
 
 /**
Index: branches/new_class_id/src/lib/particles/dot_particles.cc
===================================================================
--- branches/new_class_id/src/lib/particles/dot_particles.cc	(revision 9707)
+++ branches/new_class_id/src/lib/particles/dot_particles.cc	(revision 9709)
@@ -26,6 +26,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(DotParticles, CL_DOT_PARTICLES);
 NewObjectListDefinitionID(DotParticles, CL_DOT_PARTICLES);
+CREATE_FACTORY(DotParticles);
 
 SHELL_COMMAND(texture, DotParticles, setMaterialTexture)
Index: branches/new_class_id/src/lib/particles/model_particles.cc
===================================================================
--- branches/new_class_id/src/lib/particles/model_particles.cc	(revision 9707)
+++ branches/new_class_id/src/lib/particles/model_particles.cc	(revision 9709)
@@ -26,6 +26,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(ModelParticles, CL_MODEL_PARTICLES);
 NewObjectListDefinitionID(ModelParticles, CL_MODEL_PARTICLES);
+CREATE_FACTORY(ModelParticles);
 
 SHELL_COMMAND(texture, ModelParticles, setMaterialTexture)
